package com.offcn.api.tk.app3;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.TestUnti.VerificationMethod;
import com.offcn.interfaces.API;
import com.offcn.process.TK;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;


/**
 * 
 * @Description:   47. 人工批改--发布给学员（NWN）
 * @author: wff    
 * @date: 2019年8月8日 上午9:43:14   
 * @version V1.0
 */

public class releaseScoreToStudent extends TK implements API {
	public String parameter;//参数集合

	public String record_id_excel;//试卷使用记录id

	public String record_id;//试卷使用记录id
	
	
	@Override
	public void initialize(HashMap<String, Object> data) {
		if (!isProduct && data.get("CleanDB").toString().contains("Y")) {
			cleanUser_FromDB();//清除注册用户根据user_id
		}

		
		try {
			String sql = "SELECT use_id FROM `t_paper_use_record` WHERE  is_statis = 2 AND is_done =1 AND is_release =0 AND channel <>1 LIMIT 1";
			ResultSet rs_bankcard = this.sqlFromDB(sql);

			rs_bankcard.last();
			
				
			record_id =rs_bankcard.getString("use_id");	
			
			parameter = MapUtil.getValue("parameter", data);
			record_id_excel = MapUtil.getParameter(parameter, "record_id").trim();
			
			if ((!record_id_excel.equals("")) && record_id_excel.equals("code")) {
				
				nwn_record_id = record_id;	
			}
			
					
		} catch (Exception e) {
			
			e.printStackTrace();
		}

	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		record_id_excel = MapUtil.getParameter(parameter, "record_id").trim();
		
				
		if ((!record_id_excel.equals("")) && record_id_excel.equals("code")) {
			
			parameter = parameter.replace("\"record_id\":code", "\"record_id\":"+ record_id );
		}else {
			parameter = parameter.replace("\"record_id\":old", "\"record_id\":"+ nwn_record_id );
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {

		Map<String, String>  headers=new HashMap<String, String>();
		headers.put("Authorization", tk_token);
		
		Map<String, String>  jsonAsMap=new HashMap<String, String>();
		parameter = MapUtil.getValue("parameter", data);
		String tikuString= MapUtil.getParameter(parameter, "appid").trim();
		tikuString = MapUtil.killQuotes(tikuString, "\"");
		record_id_excel = MapUtil.getParameter(parameter, "record_id").trim();
		
		
		if ((!record_id_excel.equals("")) && record_id_excel.equals("code")) {
			
			jsonAsMap.put("record_id", record_id);
		}else {
			jsonAsMap.put("record_id", nwn_record_id);
		}
		jsonAsMap.put("appid", tikuString);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setUrl(Url);
		myRequest.setHeaders(headers);
		myRequest.setFormParameter(jsonAsMap);		
		myRequest.setRequest(Request);
		Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = StringUtils.decodeUnicode(re.asString());

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
//				if(shelf_id =="" && shelf_id.equals("")){
//					failReason = "10001";
//				}
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
//				if(shelf_id =="" && shelf_id.equals("")){
//					failReason = "参数接收失败！";
//				}
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			if("接口响应成功！".equals(msg)){
				conn=ConnectionsMap.get("tk");
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
